## yorick 2.1.06+dfsg

=== Makefile ===
# $Id: Makefile,v 1.4 2010/02/28 21:32:23 dhmunro Exp $
# see README for usage

SHELL=/bin/sh

ALLDIRS=play gist yorick regexp matrix fft doc
CONFIGDIRS=play yorick

all: yorexe gistexe docs

yorexe: libyor
	@cd yorick; $(MAKE)

gistexe: libgist
	@cd gist; $(MAKE) gist

docs: yorexe
	@cd doc; $(MAKE) docs

# libraries are built in a fixed order:
# libplay, then libgist, then libyor
#   - the libraries are accumulated, that is,
#     libyor.a contains libgist.a contains libplay.a

libyor: libgist
	@cd regexp; $(MAKE) libyor
	@cd matrix; $(MAKE) libyor
	@cd fft; $(MAKE) libyor
	@cd yorick; $(MAKE) libyor.a

libgist: libplay
	@cd gist; $(MAKE) libgist.a

libplay: Make.cfg
	@cd play; $(MAKE) libplay

LD_STATIC=
Make.cfg:
	LD_STATIC=$(LD_STATIC) ./configure

config: distclean
	@$(MAKE) "LD_STATIC=$(LD_STATIC)" Make.cfg

prefix=.
Y_PLATFORM=.
Y_SITE=.
Y_HOME=.
ysite:
	if S="s?^prefix=.*?prefix=\"$(prefix)\"?;\
	s?^Y_PLATFORM=.*?Y_PLATFORM=\"$(Y_PLATFORM)\"?;\
	s?^Y_SITE=.*?Y_SITE=\"$(Y_SITE)\"?;\
	s?^Y_HOME=.*?Y_HOME=\"$(Y_HOME)\"?";\
	sed -e "$$S" ysite.sh >ysite.sh1; then mv ysite.sh1 ysite.sh; fi
	@if test -r ysite.grp; then chmod g+w ysite.sh; fi

reloc:
	$(MAKE) Y_HOME=relocate ysite

clean::
	@rm -f Make.del yorapi.def
	@if test ! -r Make.cfg; then touch Make.cfg Make.del; fi
	@for d in $(ALLDIRS); do ( cd $$d; $(MAKE) TGT=exe clean; ); done
	@if test -r Make.del; then rm -f Make.cfg Make.del; fi
	rm -f *~ '#'* *.o cfg* ysite.sh? core a.out
	rm -f i/*~ i0/*~ i-start/*~ g/*~ extend/*~
	rm -rf relocate

distclean::
	@touch Make.cfg
	@for d in $(ALLDIRS); do ( cd $$d; $(MAKE) TGT=exe distclean; ); done
	rm -f *~ '#'* *.o cfg* Make.* ysite.sh? core a.out
	rm -f i/*~ i0/*~ i-start/*~ g/*~ extend/*~
	rm -rf relocate

siteclean: distclean
	@rm -f ysite.grp
	@$(MAKE) prefix=. Y_PLATFORM=. Y_SITE=. Y_HOME=relocate ysite


check:
	@cd yorick; $(MAKE) check

INSTALL_ROOT=
Y_BINDIR=
Y_DOCDIR=
install: yorexe gistexe docs
	./instally.sh +both "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

install1: yorexe gistexe
	./instally.sh +home "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

uninstall:
	./instally.sh -both "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

uninstall1:
	./instally.sh -home "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

dist: siteclean
	W=`pwd`;N=`basename "$$W"`;R=`tail -n 1 VERSION`;cd ..;\
	tar cvf - $$N|gzip - >$$N.$$R.tgz;

# Usage: make YGROUP=altgrp sharable
# default group is "yorick", affects instally.sh
YGROUP=yorick
sharable:
	@rm -f ysite.grp
	echo "$(YGROUP)" >ysite.grp
	chgrp -R $(YGROUP) .
	chmod -R g+w .
	find . -type d | xargs chmod g+s

relocatable: siteclean
	@rm -rf relocate
	$(MAKE) Y_HOME=relocate ysite
	$(MAKE) install
	cp install.rel relocate/README
	cp emacs/yorick.el relocate
	mkdir relocate/contrib
	W=`pwd`;N=`basename "$$W"`;R=`tail -n 1 VERSION`;\
	mv relocate $$N-$$R;tar cvf - $$N-$$R|gzip - >$$N-$$R.tgz;\
	rm -rf $$N-$$R

dumpconfig:
	@cd yorick; $(MAKE) dumpconfig

# targets for ./configure
echocc:
	echo "$(CC)" >cfg.tmp
echorl:
	echo "$(RANLIB)" >cfg.tmp
echoar:
	echo "$(AR)" >cfg.tmp
echoml:
	echo "$(MATHLIB)" >cfg.tmp
pkgconfig:
	@for d in $(CONFIGDIRS); do ( cd $$d; $(MAKE) config; ); done

=== doc/Makefile ===
# $Id: Makefile,v 1.7 2008/03/06 00:35:26 dhmunro Exp $
# you need the makeinfo and texi2dvi programs from gnu.org
# and the tex typesetting system from tug.org
# For the html-doc target, you need a recent texi2html that accepts
# "--split node". Mac users: The one in fink (1.64) is too old, get one from
# http://www.nongnu.org/texi2html/
MAKEINFO = makeinfo
TEXI2DVI = texi2dvi
#TEXI2PDF = texi2pdf
TEXI2PDF = texi2dvi --pdf
TEX = tex
PDFTEX = pdftex
YORICK = ../yorick/yorick

all: yorick.info docs

docs:
	$(YORICK) -batch maked.i

yorick.info: yorick.tex
	$(MAKEINFO) yorick.tex

yorick.dvi: yorick.tex
	$(TEXI2DVI) yorick.tex

yorick.pdf: yorick.tex
	$(TEXI2PDF) yorick.tex

refs.dvi: refs.tex
	$(TEX) refs.tex

refs.pdf: refs.tex
	$(PDFTEX) refs.tex

html-doc:
	cd html; make html-doc

TEX_AUX=*.aux *.log *.toc *.cp *.fn *.ky *.pg *.tp *.vr *.tmp
clean::
	rm -f *~ '#'* *.inf* *.dvi *.doc $(TEX_AUX)
	rm -Rf yorick/
	cd html; make clean

distclean:: clean

=== drat/Makefile ===
# $Id: Makefile,v 1.2 2007/03/25 15:36:32 dhmunro Exp $
# similar to any yorick package Makefile

COPT=$(COPT_DEFAULT)
TGT=$(DEFAULT_TGT)

# ------------------------------------------------ macros for this package
Y_MAKEDIR=..
Y_EXE=../yorick/yorick$(EXE_SFX)
PKG_NAME=drat
PKG_EXENAME=yorick
PKG_I=drat.i

OBJS=bound.o track.o trans.o drat.o ydrat.o

PKG_CLEAN=../i0/drat.i

# in ordinary yorick packages, these dependencies unnecessary
# they appear here because this package is part of baseline yorick
H_DEPS=../play/plugin.h
H_YDATA=../yorick/ydata.h ../yorick/binio.h ../yorick/hash.h
H_YWRAP=../play/play.h $(H_YDATA) $(H_DEPS)
H_YDRAT=../yorick/yio.h $(H_YDATA) ../play/pstdlib.h ../play/pstdio.h $(H_DEPS)

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
PKG_I_DEPS=$(PKG_I)

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_IDIR=-I. -I../play -I../yorick
Y_LIBEXE=../yorick
Y_EXE=../yorick/yorick$(EXE_SFX)

# ------------------------------------- targets and rules for this package

bound.o: bound.h
track.o: track.h   bound.h
trans.o: trans.h   track.h bound.h
drat.o: drat.h   trans.h track.h bound.h
ydrat.o: drat.h   trans.h track.h bound.h  $(H_YDRAT)

../i0/drat.i: drat.i
	cp -f drat.i ../i0/drat.i

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
preexe: $(PKG_LIB) ../i0/drat.i
predll:
	@:

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
postdll: $(PKG_DLL) ../i0/drat.i
postexe:
	@:

#-------------------------------------- end of Makefile

=== fft/Makefile ===
# $Id: Makefile,v 1.1.1.1 2005/09/18 22:04:52 dhmunro Exp $
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I../play
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

OBJS=cfft2.o cfftb.o cfftf.o cffti.o roll2.o

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean


cffti.o: cfft.h ../play/plugin.h
cfftf.o: cfft.h ../play/plugin.h
cfftb.o: cfft.h ../play/plugin.h
cfft2.o: cfft.h ../play/plugin.h
roll2.o: cfft.h ../play/plugin.h

=== hex/Makefile ===
# $Id: Makefile,v 1.2 2007/03/25 15:36:32 dhmunro Exp $
# similar to any yorick package Makefile

COPT=$(COPT_DEFAULT)
TGT=$(DEFAULT_TGT)

# ------------------------------------------------ macros for this package
Y_MAKEDIR=..
Y_EXE=../yorick/yorick$(EXE_SFX)
PKG_NAME=hex
PKG_EXENAME=yorick
PKG_I=hex.i

OBJS=yhex.o hex5.o hex24.o hex.o regul.o tools.o store.o hydram.o

PKG_CLEAN=../i0/hex.i ../i/ylmdec.i

# in ordinary yorick packages, these dependencies unnecessary
# they appear here because this package is part of baseline yorick
H_DEPS=../play/plugin.h
H_YDATA=../yorick/ydata.h ../yorick/binio.h ../yorick/hash.h
H_YWRAP=../play/play.h $(H_YDATA) $(H_DEPS)
H_YHEX=../yorick/yio.h $(H_YDATA) ../play/pstdlib.h ../play/pstdio.h $(H_DEPS)

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
PKG_I_DEPS=$(PKG_I)

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_IDIR=-I. -I../play -I../yorick
Y_LIBEXE=../yorick
Y_EXE=../yorick/yorick$(EXE_SFX)

# ------------------------------------- targets and rules for this package

yhex.o: hex.h  tools.h
hex5.o: hex.h  tools.h
hex.o: hex.h  tools.h
tools.o: tools.h
store.o: tools.h
hydram.o: hydram.h hex.h  tools.h

../i0/hex.i: hex.i
	cp -f hex.i ../i0/hex.i
../i/ylmdec.i: ylmdec.i
	cp ylmdec.i ../i/ylmdec.i

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
preexe: $(PKG_LIB) ../i0/hex.i ../i/ylmdec.i
predll:
	@:

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
postdll: $(PKG_DLL) ../i0/hex.i ../i/ylmdec.i
postexe:
	@:

hex.doc:
	echo 'mkdoc,["hex.i","hydra.i"],"hex.doc";quit' | $(Y_EXE) -imkdoc.i

#-------------------------------------- end of Makefile

=== matrix/Makefile ===
# $Id: Makefile,v 1.1.1.1 2005/09/18 22:04:37 dhmunro Exp $
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I. -I../play
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

CBLASY=cblasy.o

# to use external blas (e.g.- atlas), comment above, uncomment below
# also need to add -lblas (or whatever) to MATHLIB in ../Make.cfg
#CFLAGS=$(COPTIONS) -DUSE_CBLAS -DCBLAS_INDEX=int -I.
#CBLASY=

OBJS=dlamc3.o dgyor.o dgtsv.o dgesv.o dgecon.o dgels.o dgelss.o \
  dbdsqr.o dlasr.o dgesvd.o dgesv2.o $(CBLASY)

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean

# ------------- dependencies -------------

dlamc3.o: dlamc3.c
	$(CC) $(CPPFLAGS) -g -I. -I../play -c dlamc3.c

dbdsqr.o: dg.h cblasy.h ../play/plugin.h
dgecon.o: dg.h cblasy.h ../play/plugin.h
dgels.o: dg.h cblasy.h ../play/plugin.h
dgelss.o: dg.h cblasy.h ../play/plugin.h
dgesv.o: dg.h cblasy.h ../play/plugin.h
dgesv2.o: dg.h cblasy.h ../play/plugin.h
dgesvd.o: dg.h cblasy.h ../play/plugin.h
dgtsv.o: dg.h cblasy.h ../play/plugin.h
dgyor.o: dg.h cblasy.h ../play/plugin.h
dlasr.o: dg.h cblasy.h ../play/plugin.h

=== mpy/Makefile ===
# Makefile for MPY = Message Passing Yorick based on the MPI standard
# $Id: Makefile,v 1.4 2010/03/20 16:59:15 dhmunro Exp $

Y_MAKEDIR=
Y_EXE=
Y_EXE_PKGS=
Y_EXE_HOME=
Y_EXE_SITE=

# note: to be fully scalable, mpy cannot use dll packages; all
# packages should be statically linked via Y_EXE_PKGS or EXTRA_PKGS

# mpy needs custom main.c, assume this directory is a
# sibling of the play/ directory in the distribution
Y_MAIN_SRC=../play/$(Y_MAIN_C)
Y_MAIN_SRC=$(Y_EXE_HOME)/../play/$(Y_MAIN_C)

#Y_MAKEMPY=$(Y_MAKEDIR)/Makempy
Y_MAKEMPY=./Makempy

# ----------------------------------------------------- optimization flags

COPT=$(COPT_DEFAULT)
#TGT=$(DEFAULT_TGT)
TGT=exe

# ------------------------------------------------ macros for this package

PKG_NAME=mpy
PKG_I=mpy.i

OBJS=mpy.o mpyfile.o

PKG_EXENAME=mpy

# PKG_DEPLIBS=-Lsomedir -lsomelib   for dependencies of this package
PKG_DEPLIBS=
# set compiler flags specific to this package
PKG_CFLAGS=$(MPI_CFLAGS)
PKG_LDFLAGS=$(MPI_LDFLAGS)

EXTRA_PKGS=$(Y_EXE_PKGS)

PKG_CLEAN=

PKG_I_START=
PKG_I_EXTRA=custommp.i testmp.i mpy1.i

# -------------------------------- standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
# DLL_TARGETS, LIB_TARGETS, EXE_TARGETS
# are any additional targets (defined below) prerequisite to
# the plugin library, archive library, and executable, respectively
PKG_I_DEPS=$(PKG_I)
EXE_TARGETS=mpymain.o paths.i

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Makeexe

# override macros Makepkg sets for rules and other macros
Y_MAIN_O=mpymain.o

# this overrides CC and FC macros, provides MPI_CFLAGS
include $(Y_MAKEMPY)

# Y_HOME and Y_SITE in Make.cfg may not be correct (e.g.- relocatable)
#Y_HOME=$(Y_EXE_HOME)
#Y_SITE=$(Y_EXE_SITE)
# above appropriate for TGT=dll, below because this is TGT=exe
Y_BINDIR=$(Y_EXE_HOME)/bin
Y_LIBEXE=$(Y_EXE_HOME)/lib
Y_INCLUDE=$(Y_EXE_HOME)/include
DEST_Y_SITE=$(DESTDIR)$(Y_EXE_SITE)
DEST_Y_HOME=$(DESTDIR)$(Y_EXE_HOME)

# reduce chance of yorick-1.5 corrupting this Makefile
MAKE_TEMPLATE = /usr/lib/yorick/1.5/protect-against-1.5

# ------------------------------------- targets and rules for this package

# override on_launch callback with scalable MPI version
D_ON_LAUNCH=-Don_launch=mpy_on_launch
# always compile main.c with -g so new packages can be debugged
mpymain.o: mpymain.c
	$(CC) $(CPPFLAGS) $(D_ON_LAUNCH) -g $(Y_IDIR) -o $@ -c mpymain.c
mpymain.c: $(Y_MAIN_SRC)
	cp $(Y_MAIN_SRC) mpymain.c

# need paths.i to be able to run TGT=exe in this directory
# after install it is not needed
paths.i:
	echo >paths.i 'set_site,"$(Y_EXE_SITE)","$(Y_EXE_HOME)";include,"$(Y_EXE_SITE)/i0/paths.i",1;'

install:: Makempy mpy.h mpymain.o
	$(YNSTALL) Makempy "$(DEST_Y_HOME)"
	$(YNSTALL) mpy.h "$(DEST_Y_HOME)/include"
	$(YNSTALL) mpymain.o "$(DEST_Y_HOME)/lib"

uninstall::
	rm -f "$(DEST_Y_HOME)/Makempy"
	rm -f "$(DEST_Y_HOME)/include/mpy.h"
	rm -f "$(DEST_Y_HOME)/lib/mpymain.o"

clean::
	rm -f mpymain.* paths.i

distclean::
	rm -f Makempy

# -------------------------------------------------------- end of Makefile

=== play/Makefile ===
# $Id: Makefile,v 1.1.1.1 2005/09/18 22:05:31 dhmunro Exp $
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

SUBDIRS=hacks $(PLAY_DIRS) any
ALLDIRS=hacks win unix x11 any

all: libplay

# the library is actually built from subdirectories (in order)
libplay:
	@for d in $(SUBDIRS); do ( cd $$d; $(MAKE); ); done

config:
	@for d in $(PLAY_DIRS); do ( cd $$d; $(MAKE) TGT=$(TGT) config; ); done

numfmt: libplay
	cd any; $(MAKE) numfmt

test2d: libplay
	cd any; $(MAKE) test2d

clean:: cleantop
	@for dir in $(ALLDIRS); do ( cd $$dir; $(MAKE) clean; ); done

distclean:: distcleantop
	@for dir in $(ALLDIRS); do ( cd $$dir; $(MAKE) distclean; ); done

cleantop:
	rm -f *~ '#'* *.o *.a core a.out hack*.h playwin.h

distcleantop: cleantop

=== regexp/Makefile ===
# $Id: Makefile,v 1.1.1.1 2005/09/18 22:06:22 dhmunro Exp $
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I../play -I../yorick
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

OBJS=yfnmatch.o yregexp.o

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean


yfnmatch.o: yfnmatch.h ../play/plugin.h
yregexp.o: yregexp.h ../play/pstdlib.h ../play/plugin.h

=== yorick/Makefile ===
# $Id: Makefile,v 1.3 2009/07/12 04:16:14 dhmunro Exp $
# similar to any yorick package Makefile

# ------------------------------------------------ macros for yor base package
COPT=$(COPT_DEFAULT)
Y_MAKEDIR=..
Y_EXE=./yorick
PKG_NAME=yor
PKG_EXENAME=yorick
PKG_I=std.i matrix.i fft.i graph.i
PKG_I_DEPS=../i0/std.i ../i0/matrix.i ../i0/fft.i ../i0/graph.i
PKG_I_DIR=-I../i0

OBJS = opsv.o task.o yorick.o yinput.o parse.o ydata.o yapi.o yio.o fnctn.o \
  array.o range.o ops.o ops0.o ops1.o ops2.o ops3.o nonc.o debug.o \
  std0.o std1.o std2.o ascio.o defmem.o yhash.o  yrdwr.o bcast.o binio.o \
  binobj.o binstd.o cache.o convrt.o binpdb.o clog.o ystr.o graph.o fwrap.o \
  graph0.o style.o list.o pathfun.o autold.o funcdef.o spawn.o fortrn.o

PKG_CLEAN=libyor main.* prmtyp.h codger lib$(PKG_NAME).a $(PKG_EXENAME) yorapi*

PLAPI=../play/plugin.h
PLAYONLY=../play/play.h $(PLAPI)

DIST_PKGS=drat hex
DIST_LIBS=-L../drat -ldrat -L../hex -lhex
DIST_DIRS=../drat ../hex

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
H_YWRAP=$(PLAYONLY) ydata.h yapi.h binio.h hash.h
CODGER_DEP=codger
EXE_TARGETS=main.o $(YWIN_LIB) prepkg
LIB_TARGETS=libyor
ALL_TARGETS=postpkg
TGT=exe

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_MAIN_O=main.o
Y_IDIR=-I. -I../play -I../gist
Y_LIBEXE=.
Y_LDIR=-L../drat -L../hex
PKG_L_OPT=-L.
ARFLAGS=r
EXTRA_LIBS=$(ALT_LIBS)

# hack combines gist, matrix, and fft libs into a single libyor.a
# (this does not get inter-directory dependencies absolutely correct)
BUILTIN_PKGS=../gist/libgist.a ../regexp/libyor ../matrix/libyor ../fft/libyor
libyor: $(BUILTIN_PKGS)
	@rm -f $(PKG_LIB)
	cp ../gist/libgist.a $(PKG_LIB)
	cd ../regexp; $(MAKE) "COPT=$(COPT)" oinsert
	cd ../matrix; $(MAKE) "COPT=$(COPT)" oinsert
	cd ../fft; $(MAKE) "COPT=$(COPT)" oinsert
	touch $@
../gist/libgist.a:
	@cd ../gist; $(MAKE) "COPT=$(COPT)" libgist.a
../regexp/libyor:
	@cd ../regexp; $(MAKE) "COPT=$(COPT)" libyor
../matrix/libyor:
	@cd ../matrix; $(MAKE) "COPT=$(COPT)" libyor
../fft/libyor:
	@cd ../fft; $(MAKE) "COPT=$(COPT)" libyor

# MSWindows and AIX need yorapi.def for plugins to work (see ../yorapi.sh)
yorapi.def:
	cd ..; ./yorapi.sh; mv yorapi.def yorick/

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
M_V1="TGT=exe" pre$(DISTRIB_TGT)
prepkg:
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) "COPT=$(COPT)" $(M_V1); ); done

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
M_V2="TGT=dll" post$(DISTRIB_TGT)
postpkg: $(PKG_EXE)
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) "COPT=$(COPT)" $(M_V2); ); done

# two colons means these rules appended to Makepkg rule
clean::
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) TGT=exe clean; ); done
distclean::
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) TGT=exe distclean; ); done

# ------------------------------------- targets and rules for yor base package
# ydata.h: yapi.h binio.h hash.h
# binio.h: hash.h
# yio.h: hash.h pstdio.h
# defmem.h: pstdlib.h
# bcast.h: ydata.h   binio.h hash.h
HSHAPI=hash.h ../play/plugin.h
HSH=hash.h
YDATA_H=ydata.h yapi.h binio.h $(HSHAPI)
YDATA_HP=ydata.h yapi.h binio.h $(HSH)
HGIST=../gist/gist.h ../gist/hlevel.h
PSLIB=../play/pstdlib.h $(PLAPI)
PSLIO=../play/pstdlib.h ../play/pstdio.h $(PLAPI)
PSPLAY=../play/pstdlib.h ../play/play.h $(PLAPI)
PLAYALL=../play/play.h ../play/pstdlib.h ../play/pstdio.h $(PLAPI)

array.o: $(YDATA_H)
ascio.o: $(YDATA_HP) yio.h defmem.h $(PLAYALL)
autold.o: $(YDATA_HP) yio.h defmem.h $(PSLIO)
bcast.o: bcast.h   $(YDATA_H)
binio.o: $(YDATA_HP) yio.h defmem.h $(PSLIO)
binobj.o: bcast.h defmem.h $(PSLIB)   $(YDATA_HP)
binpdb.o: $(YDATA_HP) yio.h $(PSLIO)
binstd.o: binio.h $(PSLIB)   $(HSH)
cache.o: binio.h $(PSLIO)   $(HSH)
clog.o: $(YDATA_HP) yio.h $(PSLIO)
convrt.o: binio.h $(PSLIB)   $(HSH)
debug.o: $(YDATA_HP) yio.h $(PLAYALL)
defmem.o: defmem.h   $(PSLIB)
fnctn.o: $(YDATA_H)
fortrn.o: fortrn.c yasync.h $(PSLIB)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(FORTRAN_LINKAGE) -o $@ -c fortrn.c
graph.o: graph.c $(YDATA_HP) yio.h   $(PLAYALL) $(HGIST)
graph0.o: $(YDATA_H)
yhash.o: $(HSH) defmem.h $(PSLIB)
list.o: $(YDATA_H) defmem.h
nonc.o: nonc.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(NO_HYPOT) -o $@ -c nonc.c
ops.o: bcast.h $(PSLIB)   ydata.h binio.h $(HSH)
ops0.o: $(YDATA_H)
ops1.o: $(YDATA_H)
ops2.o: $(YDATA_HP)   $(PSLIB)
ops3.o: bcast.h $(PSLIB)   $(YDATA_HP)
opsv.o: $(YDATA_HP) $(PSLIB) prmtyp.h
parse.o: parse.h $(YDATA_HP) $(PSLIB)
pathfun.o: yio.h $(PSLIO)   $(HSH)
range.o: $(YDATA_HP) $(PSLIB)
std0.o: std0.c bcast.h yio.h defmem.h $(PLAYALL)   ydata.h binio.h $(HSH)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(D_Y_VERSION) -o $@ -c std0.c
std1.o: $(YDATA_HP) $(PSPLAY)
std2.o: $(YDATA_HP) yio.h $(PLAYALL)
style.o: style.c $(YDATA_HP) $(PSLIB) $(HGIST) ../gist/draw.h
task.o: $(YDATA_HP) yio.h $(PLAYALL)
yapi.o: $(YDATA_HP) yio.h bcast.h $(PSLIB)
ydata.o: bcast.h defmem.h $(PSLIB)   $(YDATA_HP)
yinput.o: yio.h parse.h $(HSH) $(PLAYALL)
yio.o: yio.h defmem.h $(YDATA_HP) $(PLAYALL)
yorick.o: yorick.c parse.h $(PSPLAY)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(D_NO_STRTOUL) -o $@ -c yorick.c
yrdwr.o: bcast.h $(PSLIB)   $(YDATA_HP)
YREH=../regexp/yfnmatch.h ../regexp/yregexp.h
ystr.o: ystr.c $(YREH) $(PSLIB) $(YDATA_HP)
	$(CC) $(CPPFLAGS) $(CFLAGS) -I../regexp -o $@ -c ystr.c

# codger code generator computes ywrap.c and yinit.c source files
CDG_FLAGS=$(CFLAGS)
codger: codger.c
	$(CC) $(CPPFLAGS) $(CDG_FLAGS) $(FORTRAN_LINKAGE) -o codger codger.c

# numfmt computes binary number formats, results in prmtyp.h
prmtyp.h: ../play/any/numfmt ../play/any/numfmt.c
	../play/any/numfmt prmtyp.h
../play/any/numfmt:
	@cd ../play; $(MAKE) numfmt

# always compile main.c with -g so new packages can be debugged
main.o: main.c $(PLAYONLY)
	$(CC) $(CPPFLAGS) -g -I../play -o $@ -c main.c
main.c: ../play/$(Y_MAIN_C)
	cp ../play/$(Y_MAIN_C) main.c

config:
	./yconfig.sh

=== distribs/yorick/Makefile ===
# New ports collection makefile for:	Yorick
# Date created:         26 Oct 97
# Whom:                 Pedro Giffuni <giffunip@asme.org>
#
# $FreeBSD: ports/lang/yorick/Makefile,v 1.14 2003/12/13 23:59:49 pav Exp $
#

# History: 1.4.1 port by Pedro Giffuni <giffunip@asme.org>
#          1.5.02 port by ports@FreeBSD.org,
#                 from submission by Ed Alley <wea@llnl.gov>
#          1.5.07 port by David H. Munro <munro1@llnl.gov>
#          1.5.12 port by David H. Munro <munro1@llnl.gov>, 01/Nov/02
#          1.5.14 port by David H. Munro <munro1@llnl.gov>, 01/Oct/03
#          1.6.02 port by David H. Munro <munro1@llnl.gov>, 12/Mar/05
# 1.5.07 notes:
# (1) info pages installed in PREFIX/info for consistency with other apps
#     -- really should be in PREFIX/share/info
# (2) several fixes to allow PREFIX for package install to be different
#     from PREFIX at build time (which is compiled into yorick and gist):
#     (a) PREFIX/bin/{yorick,gist} are softlinks, which allows
#         yorick and gist to compute ${PREFIX}/lib/${PORTNAME} at runtime
#     (b) softlink for g/ put in lib/${PORTNAME} for gist
#     (c) softlink doc/ so yorick online help is correct
#     (d) copy of paths.i put in lib/${PORTNAME}/bin for yorick
#     (e) pkg-install script added to fiddle softlinks, paths.i, and
#         Maketmpl if PREFIX has changed at install time
#     -- assume DOCSDIR and DATADIR take default values as does pkg-plist
#          1.5.08 replaces 1.5.07 infant mortality

PORTNAME=	yorick
PORTVERSION=	1.6.02
CATEGORIES=	lang math
MASTER_SITES=	ftp://ftp-icf.llnl.gov/pub/Yorick/
EXTRACT_SUFX=	.tgz

MAINTAINER=	munro1@llnl.gov
COMMENT=	Interpreted language and scientific graphics

WRKSRC=		${WRKDIR}/${PORTNAME}-${PORTVERSION:R}

USE_XLIB=	yes
MAKE_ARGS=	Y_HOME="${PREFIX}/lib/${PORTNAME}" Y_SITE="${DATADIR}" \
		Y_DOCDIR=/dev/null
MAN1=		yorick.1 gist.1
INFO=		yorick

PORTDOCS=	FILE_FORMATS README drat.doc drat.tex graph.doc hex.doc \
		library.doc math.doc refs.pdf refs.ps refs.tex std.doc \
		yorick.pdf yorick.ps yorick.tex

do-configure:
	@(cd ${CONFIGURE_WRKSRC}; ${SETENV} ${MAKE_ENV} \
		${MAKE} ${MAKE_FLAGS} ${MAKEFILE} ${MAKE_ARGS} ysite config)

post-build:
.if !defined(NOPORTDOCS)
	cd ${WRKSRC}/doc; make yorick.info
.endif

post-install:
.for file in gist yorick
	${INSTALL_MAN} ${WRKSRC}/doc/${file}.1 ${PREFIX}/man/man1
	@${STRIP_CMD} ${PREFIX}/lib/${PORTNAME}/bin/${file}
	@${LN} -sf ${PREFIX}/lib/${PORTNAME}/bin/${file} ${PREFIX}/bin/${file}
.endfor
	@${STRIP_CMD} ${PREFIX}/lib/${PORTNAME}/lib/codger
	${INSTALL_DATA} ${WRKSRC}/emacs/yorick.el ${DATADIR}
	@${LN} -sf ../../share/${PORTNAME}/g ${PREFIX}/lib/${PORTNAME}/g
	@${CP} ${DATADIR}/i0/paths.i ${PREFIX}/lib/${PORTNAME}/bin/paths.i
.if !defined(NOPORTDOCS)
	@${MKDIR} ${DOCSDIR}
.for file in ${PORTDOCS}
	${INSTALL_DATA} ${WRKSRC}/doc/${file} ${DOCSDIR}
.endfor
	@${LN} -sf ../doc/${PORTNAME} ${DATADIR}/doc
	for f in ${WRKSRC}/doc/yorick.info*; do \
	  ${INSTALL_DATA} $$f ${PREFIX}/info; \
	done
	install-info ${PREFIX}/info/yorick.info ${PREFIX}/info/dir
.endif

.include <bsd.port.mk>

=== doc/html/Makefile ===
# $Id: Makefile,v 1.6 2009/12/05 22:11:14 dhmunro Exp $
# This file is part of Yorick and shares its BSD-type copyright.
# For the "manual" target, you need a recent texi2html that accepts
# "--split node". Mac users: The one in fink (1.64) is too old, get one from
# http://www.nongnu.org/texi2html/
YORICK = ../../yorick/yorick
DESTDIR = /usr/local/share/doc/yorick
TEXI2HTML = texi2html -init_file html/texi2html.init -output yorick
#select mac or win version of ../README.html
PLATFORM=mac
BUILDDIR=compiled-doc/

all: html-doc

html-doc: html_xref manual refcard README.html README-install.html images css

css: $(BUILDDIR)doc/skull.css $(BUILDDIR)doc/style.css
$(BUILDDIR)doc/skull.css $(BUILDDIR)doc/style.css:
	mkdir -p $(BUILDDIR)doc/
	cp skull.css style.css $(BUILDDIR)doc/

images: $(BUILDDIR)doc/images/triangle3.jpg
$(BUILDDIR)doc/images/triangle3.jpg:
	mkdir -p $(BUILDDIR)doc/images
	cp -p images/*.* $(BUILDDIR)doc//images/

README-install.html: $(BUILDDIR)README.html
$(BUILDDIR)README.html:
	$(YORICK) -batch make-doc.i --to=$(BUILDDIR)doc/ ../README.html-$(PLATFORM)

html_xref: $(BUILDDIR)doc/html_xref/packages.html $(BUILDDIR)doc/html_xref/keywords-z.html
$(BUILDDIR)doc/html_xref/packages.html $(BUILDDIR)doc/html_xref/keywords-z.html:
	$(YORICK) -batch make-doc.i --to=$(BUILDDIR)doc/ html_xref

README.html: $(BUILDDIR)doc/README.html
$(BUILDDIR)doc/README.html:
	$(YORICK) -batch make-doc.i --to=$(BUILDDIR)doc/ extract_embedded

texi2html.init:
	$(YORICK) -batch make-doc.i texi2html.init

../refs.pdf:
	make -C .. refs.pdf
refcard: $(BUILDDIR)doc/refcard/index.html
$(BUILDDIR)doc/refcard/index.html: ../refs.pdf
	$(YORICK) -batch make-doc.i --to=$(BUILDDIR)doc/ refcard
	cp ../refs.pdf $(BUILDDIR)doc/refcard/refs.pdf

../yorick.pdf:
	make -C .. yorick.pdf
manual: $(BUILDDIR)doc/manual/yorick.html
$(BUILDDIR)doc/manual/yorick.html: ../yorick/yorick.html ../yorick.pdf
	mkdir -p $(BUILDDIR)doc/manual
	cp ../yorick/* ../yorick.pdf $(BUILDDIR)doc/manual

../yorick/yorick.html: texi2html.init
	cd ..; $(TEXI2HTML) yorick.tex

install: html-doc
	install -d $(DESTDIR)
	cp -a $(BUILDDIR)* $(DESTDIR)

clean:
	rm -Rf compiled-doc texi2html.init ../yorick/ *~

distclean:: clean

.PHONY: all html-doc clean distclean install html_xref manual refcard README.html README-install.html images css

=== debian/changelog ===
yorick (2.1.06+dfsg-2) unstable; urgency=low

  * Deactivate check suite on MIPS due to bug #580524.

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Thu, 06 May 2010 17:47:18 +0200

yorick (2.1.06+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Mon, 19 Apr 2010 10:56:52 +0200

yorick (2.1.05+dfsg+cvs20100408-1) unstable; urgency=low

  * New upstream (many new functions from YETI)
  * Removed two patches applied upstream (debian/patches/mpy*)

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Thu, 08 Apr 2010 17:18:27 +0200

yorick (2.1.05+dfsg+cvs20100318-1) unstable; urgency=low

  * New upstream
  * Build additional yorick-mpy-* packages
  * Fix spelling errors in manpages

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Tue, 23 Mar 2010 16:55:43 +0100

=== debian/control ===
Source: yorick
Section: science
Priority: optional
Maintainer: Thibaut Paumard <paumard@users.sourceforge.net>
Build-Depends: libx11-dev, texinfo, debhelper (>= 7.0.0), quilt (>= 0.40),
 imagemagick, po-debconf, texi2html (>= 1.82), libmpich2-dev,
 libopenmpi-dev [alpha amd64 i386 ia64 powerpc ppc64 sparc kfreebsd-i386 kfreebsd-amd64 hurd-i386]
Standards-Version: 3.8.4.0
DM-Upload-Allowed: yes
Homepage: http://yorick.sourceforge.net

Package: yorick
Architecture: any
Depends: yorick-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}, debconf
Replaces: yorick-data (<< 2.1.04+dfsg-1)
Conflicts: yorick-yutils (<= 1.5.0)
Breaks: yorick-imutil (<< 0.5.4-2~), yorick-spydr (<< 0.8.0-2~),
	yorick-curses (<< 0.1-4~)
Recommends: rlwrap, yorick-z
Suggests: yorick-cubeview, yorick-curses, yorick-dev, yorick-doc, yorick-gl,
 yorick-hdf5, yorick-imutil, yorick-mira, yorick-ml4, yorick-optimpack,
 yorick-soy, yorick-spydr, yorick-yao, yorick-yeti, yorick-yeti-fftw,
 yorick-yeti-gsl, yorick-yeti-regex, yorick-yeti-tiff, yorick-yutils,
 emacsen, curl
Description: interpreted language and scientific graphics
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The language features a compact syntax for many common array
 operations, so it processes large arrays of numbers very quickly and
 efficiently.  Superficially, yorick code resembles C code, but yorick
 variables are never explicitly declared and have a dynamic scoping
 similar to many Lisp dialects.  The yorick language is designed to be
 typed interactively at a keyboard, as well as stored in files for
 later use.
 .
 This package includes an emacs-based development environment, which
 you can launch by typing M-x yorick in emacs.

Package: yorick-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: yorick (>= ${source:Version})
Description: interpreted library for the Yorick language
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The yorick-data package contains all the architecture-independent data, which
 is mostly the standard interpreted library.

Package: yorick-dev
Architecture: any
Depends: yorick (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: development files for the Yorick interpreted language
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The yorick-dev package contains the files needed to compile (or package)
 plug-ins or custom `yorick' executables.

Package: yorick-mpy-mpich2
Architecture: any
Depends: yorick (= ${binary:Version}), yorick-mpy-common (= ${source:Version}),
 mpich2, ${shlibs:Depends}, ${misc:Depends}
Description: Message Passing Yorick (MPICH2 build)
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The MPY is a parallel version of Yorick based on the Message Passing
 Interface (MPI). This package contains a build of MPY linked against
 MPICH2.

Package: yorick-mpy-openmpi
Architecture: alpha amd64 i386 ia64 powerpc ppc64 sparc kfreebsd-i386 kfreebsd-amd64 hurd-i386
Depends: yorick (= ${binary:Version}), yorick-mpy-common (= ${source:Version}),
 openmpi-bin, ${shlibs:Depends}, ${misc:Depends}
Description: Message Passing Yorick (OpenMPI build)
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The MPY is a parallel version of Yorick based on the Message Passing
 Interface (MPI). This package contains a build of MPY linked against
 OpenMPI.

Package: yorick-mpy-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: yorick-mpy-openmpi (>= ${source:Version}) | yorick-mpy-mpich2 (>= ${source:Version})
Description: Message Passing Yorick (common files)
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The MPY is a parallel version of Yorick based on the Message Passing
 Interface (MPI). This package contains the files common to all
 builds of MPY.

Package: yorick-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: yorick (>= 2.1.04+dfsg+cvs20071130)
Description: documentation for the Yorick interpreted language
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The Yorick package ships with little documentation: a manpage, the
 Yorick Manual in info format, and its own "help" command. This
 package adds the Yorick Manual and Quick Reference in PDF and HTML
 format and a utility (update-yorickdoc) to build HTML documentation
 for the set of functions (from Yorick and add-on packages) installed
 on this machine. By default, these pages are built and updated
 automatically whenever necessary.
 .
 Once this package is installed, simply point your preferred web
 browser to file:///usr/share/doc/yorick-doc/README.html .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

# start by saving the path to debian/rules (useful in get-orig-source)
PATH_TO_DEBIAN := $(shell dirname $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))

# This has to be exported to make some magic below work.
export DH_OPTIONS

#CFLAGS = -Wall -g -mno-check-zero-division 

#ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#	CFLAGS += -O0
#else
#	CFLAGS += -O2
#endif

#CC = gcc 
#CFLAGS = -mno-check-zero-division
#export CC CFLAGS

check:
	dh_testdir
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
# Untill 559406 is closed, also 580524
ifeq (,$(filter $(DEB_HOST_ARCH), hppa ia64 hurd-i386 mips))
	relocate/bin/yorick -batch debian/check.i
endif
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	make Y_HOME=relocate ysite
	chmod a+x debian/helpers/*.i
	touch configure-stamp


BUILDDIR=../../build/
build: build-stamp
build-stamp: configure-stamp 
	dh_testdir
	$(MAKE) install
	-rm relocate/LICENSE
	$(MAKE) -C doc yorick.info
	mkdir -p build/share
	mkdir -p build/lib/yorick
	cp -a relocate build/share/yorick
	mv build/share/yorick/doc build
	cp debian/helpers/README build/doc
	mkdir -p build/share/yorick/packages/installed
	mv build/share/yorick/bin build/lib/yorick/
	mv build/share/yorick/lib build/lib/yorick/
	mkdir -p build/yorick-dev/share/yorick/
	mkdir -p build/yorick-dev/lib/yorick/lib/
	mv build/share/yorick/Make* build/yorick-dev/share/yorick/
	mv build/share/yorick/include build/yorick-dev/share/yorick/
	cd build/lib/yorick/lib; \
	   mv codger install.grp install.sh libdep.sh libyor.a main.o \
              $(CURDIR)/build/yorick-dev/lib/yorick/lib
	cp emacs/yorick-auto.el build/50yorick-auto.el
	convert icons/yicon32.png build/yorick32x32.xpm
	convert icons/yicon16.png build/yorick16x16.xpm
	$(MAKE) -C doc/html BUILDDIR=$(BUILDDIR) manual refcard $(BUILDDIR)doc/README.html $(BUILDDIR)doc/images/triangle3.jpg $(BUILDDIR)doc/skull.css
	cp doc/html/packinfo.txt build/00yorick.packinfo
	cp doc/html/keywords.txt build/00yorick.keywords
	cp doc/html/aliases.txt build/00yorick.aliases
	touch build-stamp

build-mpy-stamp: build-stamp
	cp -a mpy mpy.mpich2
	(cd mpy.mpich2 ; \
	./configure --yorick=../relocate/bin/yorick --mpicc=mpicc.mpich2 ; \
	$(MAKE))
	mv mpy.mpich2/mpy mpy.mpich2/mpy.mpich2
	mv mpy.mpich2/libmpy.a mpy.mpich2/libmpy.mpich2.a
	mv mpy.mpich2/Makempy mpy.mpich2/Makempy.mpich2
	mv mpy.mpich2/mpymain.o mpy.mpich2/mpymain.mpich2.o
ifeq ($(wildcard /usr/bin/mpicc.openmpi), /usr/bin/mpicc.openmpi)
	cp -a mpy mpy.openmpi
	(cd mpy.openmpi ; \
	./configure --yorick=../relocate/bin/yorick --mpicc=mpicc.openmpi ; \
	$(MAKE))
	mv mpy.openmpi/mpy mpy.openmpi/mpy.openmpi
	mv mpy.openmpi/libmpy.a mpy.openmpi/libmpy.openmpi.a
	mv mpy.openmpi/Makempy mpy.openmpi/Makempy.openmpi
	mv mpy.openmpi/mpymain.o mpy.openmpi/mpymain.openmpi.o
endif
	touch build-mpy-stamp

clean-mpy:
	rm -Rf build-mpy-stamp mpy.mpich2 mpy.openmpi

clean: configure-stamp clean-mpy
	dh_testdir
	dh_testroot
	rm -Rf build-stamp configure-stamp build relocate
	$(MAKE) distclean
#	$(MAKE) Y_HOME=. ysite
	$(MAKE) -C doc/html clean
	dh_clean

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs
	dh_install
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installinfo
	dh_installdebconf
	dh_installman
	dh_link
	dh_strip
	dh_usrlocal
	dh_compress 
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
#binary-indep: build-indep install-indep
binary-indep: build-stamp
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-mpy-stamp check
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

###### Getting the original source:
Y_VERS:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/+.*//')
CVSTAG:=y_$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/+.*//' | tr . _)
CVSROOT:=:pserver:anonymous:@yorick.cvs.sourceforge.net:/cvsroot/yorick
CVSDATE:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/.*cvs//' | sed 's/-.*//' | awk '{ printf "%08.0f", $$1+1 }')
CVSVERSDATE:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/.*cvs//' | sed 's/-.*//')
CVSVERS:=$(Y_VERS)+dfsg+cvs$(CVSVERSDATE).orig
ORIG_URL:=http://dl.sourceforge.net/sourceforge/yorick/
ORIG_TGZ:=yorick-$(Y_VERS).tgz
# Non-DFSG-free files (see copyright):
PRUNEFILES:=play/hacks/hack103.c i/idlsave.i opengl

# Use this rule to get the original sources if the current version contains
# "+cvsyyyymmdd". Breaks when sourceforge change their CVS access.
#
# WARNING: Side effect: this will use and remove the
# directory "orig-sources" and overwrite yorick-(version).orig/
# and yorick_(version).orig.tar.gz.
get-cvs-date:
	-rm -Rf ../orig-sources
	mkdir ../orig-sources
	cvs -d$(CVSROOT) login
	cd ../orig-sources ; cvs -z3 -d$(CVSROOT) export -D $(CVSDATE) yorick
	-rm -Rf ../yorick-$(CVSVERS)
	mv ../orig-sources/yorick ../yorick-$(CVSVERS)
	rm -Rf ../orig-sources
	cd ../yorick-$(CVSVERS); rm -Rf $(PRUNEFILES)
	cd ..; tar cf yorick_$(CVSVERS).tar yorick-$(CVSVERS)
	bzip2 -9 ../yorick_$(CVSVERS).tar

# check copyright to see whether was from cvs or from tgz.
get-cvs-tag:
	-rm -Rf ../orig-sources
	mkdir ../orig-sources
	cvs -d$(CVSROOT) login
	cd ../orig-sources ; cvs -z3 -d$(CVSROOT) export -r $(CVSTAG) yorick
	-rm -Rf ../yorick-$(CVSVERS)
	mv ../orig-sources/yorick ../yorick-$(Y_VERS)+dfsg
	rm -Rf ../orig-sources
	cd ../yorick-$(Y_VERS)+dfsg; rm -Rf $(PRUNEFILES)
	cd ..; tar cf yorick_$(Y_VERS)+dfsg.orig.tar yorick-$(Y_VERS)+dfsg
	gzip -9 ../yorick_$(Y_VERS)+dfsg.orig.tar

get-tgz:
	cd ..; wget $(ORIG_URL)$(ORIG_TGZ)
	cd ..; tar xvzf $(ORIG_TGZ)
	mv ../yorick-2.1 ../yorick-$(CVSVERS)
	cd ../yorick-$(CVSVERS); rm -Rf $(PRUNEFILES)
	cd ..; tar cf yorick_$(CVSVERS).tar yorick-$(CVSVERS)
	gzip -9 ../yorick_$(CVSVERS).tar

get-orig-source get-orig-sources:
	echo "For a stable release try get-tgz or get-cvs-tag"
	echo "for a +cvs release try get-cvs-date"

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary configure clean-mpy

## yorick 2.2.01%2bdfsg

=== debian/changelog ===
yorick (2.2.01+dfsg-2) unstable; urgency=low

  * Add yorick-dbg package
  * Add Vcs-Git and Vcs-Browser control fields
  * Update list of achitectures for openmpi
  * include /usr/share/dpkg/buildflags.mk in debian/rules

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Tue, 27 Sep 2011 11:51:07 +0200

yorick (2.2.01+dfsg-1) unstable; urgency=low

  * New upstream from git repository (tagged release)
  * Fix lintian warnings (bump standards version)

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Mon, 26 Sep 2011 22:10:42 +0200

yorick (2.2.00+dfsg+cvs20100907-1) experimental; urgency=low

  * New upstream release from CVS: experimental object-oriented features.
    See http://yorick.sourceforge.net/phpBB2/viewtopic.php?t=299
  * Check against policy 3.9.1

 -- Thibaut Paumard <paumard@users.sourceforge.net>  Wed, 08 Sep 2010 17:41:17 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Thibaut Paumard <paumard@users.sourceforge.net>
 Build-Depends: libx11-dev, texinfo, debhelper (>= 7.0.0), quilt (>= 0.40),
  imagemagick, po-debconf, texi2html (>= 1.82), libmpich2-dev,
- libopenmpi-dev [alpha amd64 i386 ia64 powerpc ppc64 sparc kfreebsd-i386 kfreebsd-amd64 hurd-i386]
-Standards-Version: 3.8.4.0
+ libopenmpi-dev [alpha amd64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe ppc64 sparc sparc64]
+Standards-Version: 3.9.2
 DM-Upload-Allowed: yes
+Vcs-Git: git://github.com/paumard/yorick.git
+Vcs-Browser: https://github.com/paumard/yorick
 Homepage: http://yorick.sourceforge.net
 
 Package: yorick
@@ -39,6 +41,21 @@
  .
  This package includes an emacs-based development environment, which
  you can launch by typing M-x yorick in emacs.
+
+Package: yorick-dbg
+Section: debug
+Priority: extra
+Architecture: any
+Depends: yorick (= ${binary:Version}), ${misc:Depends}
+Description: debugging symbols for Yorick
+ Yorick is an interpreted programming language for:
+  * scientific simulations or calculations
+  * postprocessing or steering large simulation codes
+  * interactive scientific graphics
+  * reading, writing, and translating large files of numbers
+ .
+ This package contains the debugging symbols for the yorick
+ executable.
 
 Package: yorick-data
 Architecture: all
@@ -83,7 +100,7 @@
  MPICH2.
 
 Package: yorick-mpy-openmpi
-Architecture: alpha amd64 i386 ia64 powerpc ppc64 sparc kfreebsd-i386 kfreebsd-amd64 hurd-i386
+Architecture: alpha amd64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe ppc64 sparc sparc64
 Depends: yorick (= ${binary:Version}), yorick-mpy-common (= ${source:Version}),
  openmpi-bin, ${shlibs:Depends}, ${misc:Depends}
 Description: Message Passing Yorick (OpenMPI build)

## yorick 2.2.01+dfsg

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 # Modified to make a template file for a multi-binary package with separated
 # build-arch and build-indep targets  by Bill Allombert 2001
 
+DPKG_EXPORT_BUILDFLAGS = 1
+-include /usr/share/dpkg/buildflags.mk
+
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
@@ -20,18 +23,6 @@
 
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
-
-#CFLAGS = -Wall -g -mno-check-zero-division 
-
-#ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-#	CFLAGS += -O0
-#else
-#	CFLAGS += -O2
-#endif
-
-#CC = gcc 
-#CFLAGS = -mno-check-zero-division
-#export CC CFLAGS
 
 check:
 	dh_testdir
@@ -51,7 +42,9 @@
 
 
 BUILDDIR=../../build/
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp: configure-stamp 
 	dh_testdir
 	$(MAKE) install
@@ -107,11 +100,11 @@
 
 clean: configure-stamp clean-mpy
 	dh_testdir
-	dh_testroot
 	rm -Rf build-stamp configure-stamp build relocate
+	touch Make.cfg
+	$(MAKE) -C doc/html clean
 	$(MAKE) distclean
 #	$(MAKE) Y_HOME=. ysite
-	$(MAKE) -C doc/html clean
 	dh_clean
 
 # Must not depend on anything. This is to be called by
@@ -131,7 +124,8 @@
 	dh_installdebconf
 	dh_installman
 	dh_link
-	dh_strip
+	dh_strip -pyorick --dbg-package=yorick-dbg
+	dh_strip -pyorick-dev -pyorick-mpy-openmpi -pyorick-mpy-mpich2
 	dh_usrlocal
 	dh_compress 
 	dh_fixperms
@@ -151,59 +145,47 @@
 	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common
 
 ###### Getting the original source:
+Y_FULL_VERS:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/-[0-9].*//')
 Y_VERS:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/+.*//')
-CVSTAG:=y_$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/+.*//' | tr . _)
-CVSROOT:=:pserver:anonymous:@yorick.cvs.sourceforge.net:/cvsroot/yorick
-CVSDATE:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/.*cvs//' | sed 's/-.*//' | awk '{ printf "%08.0f", $$1+1 }')
-CVSVERSDATE:=$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/.*cvs//' | sed 's/-.*//')
-CVSVERS:=$(Y_VERS)+dfsg+cvs$(CVSVERSDATE).orig
-ORIG_URL:=http://dl.sourceforge.net/sourceforge/yorick/
-ORIG_TGZ:=yorick-$(Y_VERS).tgz
+GIT_TAG:=y_$(shell dpkg-parsechangelog -l$(PATH_TO_DEBIAN)/changelog | grep Version | sed 's/Version: //' | sed 's/+.*//' | tr . _)
+GIT_REPO=git://github.com/dhmunro/yorick.git
+
 # Non-DFSG-free files (see copyright):
 PRUNEFILES:=play/hacks/hack103.c i/idlsave.i opengl
 
-# Use this rule to get the original sources if the current version contains
-# "+cvsyyyymmdd". Breaks when sourceforge change their CVS access.
-#
-# WARNING: Side effect: this will use and remove the
-# directory "orig-sources" and overwrite yorick-(version).orig/
-# and yorick_(version).orig.tar.gz.
-get-cvs-date:
+# make orig.tar.bz2 from current source dir, pruning PRUNEFILES
+orig-tbz:
+	rm -Rf $(PRUNEFILES)
+	cd .. ; \
+	  mv `basename $(CURDIR)` yorick-$(Y_FULL_VERS) ; \
+	  tar cvf - yorick-$(Y_FULL_VERS) --exclude=.pc --exclude=.git \
+	    --exclude=yorick-$(Y_FULL_VERS)/debian --exclude=.gitignore \
+	    | bzip2 -9 > yorick_$(Y_FULL_VERS).orig.tar.bz2
+
+
+get-orig-source:
 	-rm -Rf ../orig-sources
 	mkdir ../orig-sources
-	cvs -d$(CVSROOT) login
-	cd ../orig-sources ; cvs -z3 -d$(CVSROOT) export -D $(CVSDATE) yorick
-	-rm -Rf ../yorick-$(CVSVERS)
-	mv ../orig-sources/yorick ../yorick-$(CVSVERS)
-	rm -Rf ../orig-sources
-	cd ../yorick-$(CVSVERS); rm -Rf $(PRUNEFILES)
-	cd ..; tar cf yorick_$(CVSVERS).tar yorick-$(CVSVERS)
-	bzip2 -9 ../yorick_$(CVSVERS).tar
-
-# check copyright to see whether was from cvs or from tgz.
-get-cvs-tag:
-	-rm -Rf ../orig-sources
-	mkdir ../orig-sources
-	cvs -d$(CVSROOT) login
-	cd ../orig-sources ; cvs -z3 -d$(CVSROOT) export -r $(CVSTAG) yorick
-	-rm -Rf ../yorick-$(CVSVERS)
+	cd ../orig-sources ; \
+	  git clone $(GIT_REPO) ; \
+	  cd yorick ; \
+	  git checkout $(GIT_TAG) ; \
+	  rm -Rf $(PRUNEFILES)
+	-rm -Rf ../yorick-$(Y_VERS)
 	mv ../orig-sources/yorick ../yorick-$(Y_VERS)+dfsg
 	rm -Rf ../orig-sources
-	cd ../yorick-$(Y_VERS)+dfsg; rm -Rf $(PRUNEFILES)
-	cd ..; tar cf yorick_$(Y_VERS)+dfsg.orig.tar yorick-$(Y_VERS)+dfsg
-	gzip -9 ../yorick_$(Y_VERS)+dfsg.orig.tar
+	cd ..; tar cf - --exclude=.git --exclude=.gitignore \
+	  yorick-$(Y_VERS)+dfsg | \
+	  bzip2 --best > yorick_$(Y_VERS)+dfsg.orig.tar.bz2
 
-get-tgz:
-	cd ..; wget $(ORIG_URL)$(ORIG_TGZ)
-	cd ..; tar xvzf $(ORIG_TGZ)
-	mv ../yorick-2.1 ../yorick-$(CVSVERS)
-	cd ../yorick-$(CVSVERS); rm -Rf $(PRUNEFILES)
-	cd ..; tar cf yorick_$(CVSVERS).tar yorick-$(CVSVERS)
-	gzip -9 ../yorick_$(CVSVERS).tar
-
-get-orig-source get-orig-sources:
-	echo "For a stable release try get-tgz or get-cvs-tag"
-	echo "for a +cvs release try get-cvs-date"
+gitclean: clean
+	-quilt pop -a
+	if test -e .pc ; then \
+	   cd .pc ; \
+	   rm .quilt_patches .quilt_series .version ; \
+	   cd .. ; rmdir .pc ; \
+	   fi
 
 binary: binary-arch binary-indep
-.PHONY: build clean binary-indep binary-arch binary configure clean-mpy
+.PHONY: build-arch build-indep build clean binary-indep binary-arch binary \
+	configure clean-mpy gitclean
